Index: /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/ccd/ccd_simulator.h	(revision 504)
@@ -0,0 +1,136 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#ifndef CCDSIM_H
+#define CCDSIM_H
+
+#include "indibase/indiccd.h"
+
+/*  Some headers we need */
+#include <math.h>
+#include <sys/time.h>
+
+
+class CCDSim : public INDI::CCD
+{
+    protected:
+    private:
+
+        bool InExposure;
+        float ExposureRequest;
+        struct timeval ExpStart;
+
+        bool InGuideExposure;
+        float GuideExposureRequest;
+        struct timeval GuideExpStart;
+
+        float CalcTimeLeft(timeval,float);
+
+        int testvalue;
+        int ShowStarField;
+        int bias;
+        int maxnoise;
+        int maxval;
+        float skyglow;
+        float limitingmag;
+        float saturationmag;
+        float seeing;
+        float ImageScalex;
+        float ImageScaley;
+        float focallength;
+        float OAGoffset;
+        float TimeFactor;
+        //  our zero point calcs used for drawing stars
+        float k;
+        float z;
+
+        bool AbortGuideFrame;
+
+        float RA;
+        float Dec;
+        float GuideRate;
+
+        float PEPeriod;
+        float PEMax;
+        time_t RunStart;
+
+        //  We are going to snoop these from a telescope
+        INumberVectorProperty EqNV;
+        INumber EqN[2];
+
+        //  And this lives in our simulator settings page
+
+        INumberVectorProperty *SimulatorSettingsNV;
+        INumber SimulatorSettingsN[13];
+
+        ITextVectorProperty *TelescopeTV; //  A text vector that stores the telescope we want to snoop
+        IText TelescopeT[1];
+
+        //ISwitch ConfigSaveRestoreS[2];
+        //ISwitchVectorProperty ConfigSaveRestoreSV;
+
+        ISwitch TimeFactorS[3];
+        ISwitchVectorProperty *TimeFactorSV;
+
+        bool SetupParms();
+
+    public:
+        CCDSim();
+        virtual ~CCDSim();
+
+        const char *getDefaultName();
+
+        bool initProperties();
+        bool updateProperties();
+
+        void ISGetProperties (const char *dev);
+        void ISSnoopDevice (XMLEle *root);
+
+
+
+        bool Connect();
+        bool Disconnect();
+
+        int StartExposure(float duration);
+        int StartGuideExposure(float);
+        bool AbortGuideExposure();
+
+
+        void TimerHit();
+
+        int DrawCcdFrame();
+        int DrawGuiderFrame();
+
+        int DrawImageStar(float,float,float);
+        int AddToPixel(int,int,int);
+
+        int GuideNorth(float);
+        int GuideSouth(float);
+        int GuideEast(float);
+        int GuideWest(float);
+
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+
+};
+
+#endif // CCDSim_H
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.cpp	(revision 504)
@@ -0,0 +1,102 @@
+#include "filter_simulator.h"
+
+
+// We declare an auto pointer to FilterSim.
+std::auto_ptr<FilterSim> filter_sim(0);
+
+void ISPoll(void *p);
+
+
+void ISInit()
+{
+   static int isInit =0;
+
+   if (isInit == 1)
+       return;
+
+    isInit = 1;
+    if(filter_sim.get() == 0) filter_sim.reset(new FilterSim());
+    //IEAddTimer(POLLMS, ISPoll, NULL);
+
+}
+
+void ISGetProperties(const char *dev)
+{
+        ISInit();
+        filter_sim->ISGetProperties(dev);
+}
+
+void ISNewSwitch(const char *dev, const char *name, ISState *states, char *names[], int num)
+{
+        ISInit();
+        filter_sim->ISNewSwitch(dev, name, states, names, num);
+}
+
+void ISNewText(	const char *dev, const char *name, char *texts[], char *names[], int num)
+{
+        ISInit();
+        filter_sim->ISNewText(dev, name, texts, names, num);
+}
+
+void ISNewNumber(const char *dev, const char *name, double values[], char *names[], int num)
+{
+        ISInit();
+        filter_sim->ISNewNumber(dev, name, values, names, num);
+}
+
+void ISNewBLOB (const char *dev, const char *name, int sizes[], int blobsizes[], char *blobs[], char *formats[], char *names[], int n)
+{
+  INDI_UNUSED(dev);
+  INDI_UNUSED(name);
+  INDI_UNUSED(sizes);
+  INDI_UNUSED(blobsizes);
+  INDI_UNUSED(blobs);
+  INDI_UNUSED(formats);
+  INDI_UNUSED(names);
+  INDI_UNUSED(n);
+}
+void ISSnoopDevice (XMLEle *root)
+{
+    INDI_UNUSED(root);
+}
+
+
+FilterSim::FilterSim()
+{
+    //ctor
+}
+
+FilterSim::~FilterSim()
+{
+    //dtor
+}
+
+const char *FilterSim::getDefaultName()
+{
+    return (char *)"Filter Simulator";
+}
+
+bool FilterSim::Connect()
+{
+    CurrentFilter=1;
+    MinFilter=1;
+    MaxFilter=7;
+    return true;
+}
+
+bool FilterSim::Disconnect()
+{
+    return true;
+}
+
+int FilterSim::SelectFilter(int f)
+{
+    CurrentFilter=f;
+    SetTimer(500);
+    return 0;
+}
+
+void FilterSim::TimerHit()
+{
+    SelectFilterDone(CurrentFilter);
+}
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 504)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/filter_simulator.h	(revision 504)
@@ -0,0 +1,44 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#ifndef FILTERSIM_H
+#define FILTERSIM_H
+
+#include "indibase/indifilterwheel.h"
+
+class FilterSim : public INDI::FilterWheel
+{
+    protected:
+    private:
+    public:
+        FilterSim();
+        virtual ~FilterSim();
+
+        const char *getDefaultName();
+
+        bool Connect();
+        bool Disconnect();
+        int SelectFilter(int);
+        void TimerHit();
+
+};
+
+#endif // FILTERSIM_H
Index: /BAORadio/libindi/libindi/drivers/filter_wheel/trutech_wheel.c
===================================================================
--- /BAORadio/libindi/libindi/drivers/filter_wheel/trutech_wheel.c	(revision 503)
+++ /BAORadio/libindi/libindi/drivers/filter_wheel/trutech_wheel.c	(revision 504)
@@ -168,7 +168,7 @@
 		unsigned char type = 0x03;
 		unsigned char chksum = COMM_INIT + type + COMM_FILL;
-		/*char filter_command[5] = { COMM_PRE, COMM_INIT, type, COMM_FILL, chksum };*/
                 unsigned char filter_command[CMD_SIZE];
-		snprintf(filter_command, CMD_SIZE,  "%c%c%c%c%c", COMM_PRE, COMM_INIT, type, COMM_FILL, chksum);
+                //snprintf(filter_command, CMD_SIZE,  "%c%c%c%c%c", COMM_PRE, COMM_INIT, type, COMM_FILL, chksum);
+                snprintf(filter_command, CMD_SIZE,  "%c%c%c%c", COMM_INIT, type, COMM_FILL, chksum);
 
 		if (checkPowerS(&HomeSP))
@@ -181,6 +181,6 @@
                 if (DEBUG_ON)
                 {
-                    IDLog("Home Search Command (int): #%d#%d#%d#%d#%d#\n",COMM_PRE, COMM_INIT, type, COMM_FILL, chksum);
-                    IDLog("Home Search Command (char): #%c#%c#%c#%c#%c#\n",COMM_PRE, COMM_INIT, type, COMM_FILL, chksum);
+                    IDLog("Home Search Command (int): #%d#%d#%d#%d#\n",COMM_INIT, type, COMM_FILL, chksum);
+                    IDLog("Home Search Command (char): #%c#%c#%c#%c#\n",COMM_INIT, type, COMM_FILL, chksum);
                 }
 
@@ -273,10 +273,11 @@
 			IUUpdateNumber(&FilterPositionNP, values, names, n);
 
-                        snprintf(filter_command, CMD_SIZE,  "%c%c%c%c%c", COMM_PRE, COMM_INIT, type, targetFilter, chksum);
+                        //snprintf(filter_command, CMD_SIZE,  "%c%c%c%c%c", COMM_PRE, COMM_INIT, type, targetFilter, chksum);
+                        snprintf(filter_command, CMD_SIZE,  "%c%c%c%c", COMM_INIT, type, targetFilter, chksum);
 
                         if (DEBUG_ON)
                         {
-                            IDLog("Filter Position Command (int): #%d#%d#%d#%d#%d#\n",COMM_PRE, COMM_INIT, type, targetFilter, chksum);
-                            IDLog("Filter Position Command (char): #%c#%c#%c#%c#%c#\n",COMM_PRE, COMM_INIT, type, targetFilter, chksum);
+                            IDLog("Filter Position Command (int): #%d#%d#%d#%d#\n", COMM_INIT, type, targetFilter, chksum);
+                            IDLog("Filter Position Command (char): #%c#%c#%c#%c#\n", COMM_INIT, type, targetFilter, chksum);
                         }
 
